Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 282700)
+++ channels/chan_skinny.c	(working copy)
@@ -128,6 +128,11 @@
 	</manager>
  ***/
 
+/* Hack for easy user debugging */
+#ifndef SKINNY_DEVMODE
+#define SKINNY_DEVMODE
+#endif
+
 #ifdef SKINNY_DEVMODE
 #define SKINNY_DEVONLY(code)	\
 	code
@@ -4164,9 +4169,11 @@
 	   for some reason, transmit_callinfo must be before transmit_callstate,
 	   or you won't get keypad messages in some situations. */
 	transmit_callinfo(d,
-		S_COR(ast->connected.id.name.valid, ast->connected.id.name.str, ""),
-		S_COR(ast->connected.id.number.valid, ast->connected.id.number.str, ""),
-		l->lastnumberdialed, l->lastnumberdialed, l->instance, sub->callid, 2);
+		S_COR(ast->caller.id.name.valid, ast->caller.id.name.str, ""),
+		S_COR(ast->caller.id.number.valid, ast->caller.id.number.str, ""),
+		l->lastnumberdialed,
+		l->lastnumberdialed, 
+		l->instance, sub->callid, 2);
 	transmit_callstate(d, sub->parent->instance, sub->callid, SKINNY_CONNECTED);
 	transmit_selectsoftkeys(d, l->instance, sub->callid, KEYDEF_CONNECTED);
 	transmit_dialednumber(d, l->lastnumberdialed, l->instance, sub->callid);
@@ -4363,12 +4370,22 @@
 		return "Hold";
 	case AST_CONTROL_UNHOLD:
 		return "Unhold";
+	case AST_CONTROL_VIDUPDATE:
+		return "VidUpdate";
 	case AST_CONTROL_SRCUPDATE:
 		return "Media Source Update";
+	case AST_CONTROL_TRANSFER:
+		return "Transfer";
 	case AST_CONTROL_CONNECTED_LINE:
 		return "Connected Line";
 	case AST_CONTROL_REDIRECTING:
 		return "Redirecting";
+	case AST_CONTROL_T38_PARAMETERS:
+		return "T38_Parameters";
+	case AST_CONTROL_CC:
+		return "CC Not Possible";
+	case AST_CONTROL_SRCCHANGE:
+		return "Media Source Change";
 	case -1:
 		return "Stop tone";
 	default:
@@ -5332,9 +5349,6 @@
 		sub = l->activesub;
 	}
 
-	/* Not ideal, but let's send updated time at onhook and offhook, as it clears the display */
-	transmit_definetimedate(d);
-	
 	transmit_ringer_mode(d, SKINNY_RING_OFF);
 	l->hookstate = SKINNY_OFFHOOK;
 
@@ -5350,6 +5364,9 @@
 		/* We're answering a ringing call */
 		setsubstate_connected(sub);
 	} else {
+		/* Not ideal, but let's send updated time at onhook and offhook, as it clears the display */
+		transmit_definetimedate(d);
+		
 		if (sub && sub->owner) {
 			ast_debug(1, "Current sub [%s] already has owner\n", sub->owner->name);
 		} else {
@@ -5404,6 +5421,8 @@
 
 	if (l->hookstate == SKINNY_ONHOOK) {
 		/* Something else already put us back on hook */
+		/* Not ideal, but let's send updated time anyway, as it clears the display */
+		transmit_definetimedate(d);
 		return 0;
 	}
 
